#include <stdlib.h>
#include <math.h>
#include "SequencesOld.h"
#include "Utils.h"


#define INC_BUFFER_SEQ 1000
#define INC_BUFFER_DEB 10
#define INC_BUFFER_ANC 10

typedef struct ELEMENT_PILE {
	long lettre;
	long indice;
} Element_Pile;


static void ConstruitPremSuiv(Sequences *seq); 

Sequences toOldSequences(TypeSetOfSequences set) {
	Sequences one;
	TypePosition totalSize, ind;
	TypeNumber n;
	
	one.cardinal = set.cardinal;
	one.nombre = set.number;
	one.debut = (long*) monmalloc((one.nombre+1)*sizeof(long));
	one.debut[0] = 0;
	one.taille = 0;
	for(n=0; n<set.number; n++) {
		one.debut[n+1] = one.debut[n]+set.size[n]+1;
		one.taille += set.size[n]+1;
	}
	one.taille--;
	one.sequence = (long*) monmalloc(one.taille*sizeof(long));
	ind = 0;
	for(n=0; n<set.number; n++) {
		TypePosition p;
		for(p=0; p<set.size[n]; p++)
			if(set.sequence[n][p]<one.cardinal)
				one.sequence[ind++] = set.sequence[n][p];
			else
				one.sequence[ind++] = 0;
		if(n<set.number-1)
			one.sequence[ind++] = SEP;
	}
	one.premiere = (long*) monmalloc(one.cardinal*sizeof(long));
	one.suivant = (long*) monmalloc(one.taille*sizeof(long));
	ConstruitPremSuiv(&one);
	return one;
}

/*Lit l'ensemble de sequences contenu dans le fichier texte "F", et renvoie la structure correspondante
Le format est le suivant : les sequences sont des nombres separes 
par des espaces, les sequences sont separees par des sauts de lignes*/
Sequences LitSequences(FILE *f) {
	char c;
	long i, position, lettre, tailleBufferSeq, tailleBufferDeb, *bufferSeq, *bufferDeb;
	Sequences seq;

	seq.taille = 0L; seq.cardinal = 0L; seq.nombre = 1L;
	tailleBufferSeq = INC_BUFFER_SEQ;
	bufferSeq = (long *) monmalloc(tailleBufferSeq*sizeof(long));
	tailleBufferDeb = INC_BUFFER_DEB;
	bufferDeb = (long *) monmalloc(tailleBufferDeb*sizeof(long));
	bufferDeb[0] = 0L;
	c = getc(f);
	while(c != EOF) {
		if((c >= '0') && (c <= '9')) {
			long tmp = c - '0';
			while(((c=getc(f)) != EOF) && (c >= '0') && (c <= '9'))
				tmp = tmp*10+c-'0';
			if(tmp>seq.cardinal)
				seq.cardinal = tmp;
			if(seq.taille>=tailleBufferSeq) {
				tailleBufferSeq += INC_BUFFER_SEQ;
				bufferSeq = (long *) monrealloc((void *) bufferSeq, tailleBufferSeq*sizeof(long));
			}
			bufferSeq[seq.taille++] = tmp;
		} else {
			if(c == '\r' || c == '\n') {
				while(((c=getc(f)) != EOF) && (c == '\r' || c == '\n'))
				;
				if(seq.taille>=tailleBufferSeq) {
					tailleBufferSeq += INC_BUFFER_SEQ;
					bufferSeq = (long *) monrealloc((void *) bufferSeq, tailleBufferSeq*sizeof(long));
				}
				bufferSeq[seq.taille++] = SEP;
				if(seq.nombre>=tailleBufferDeb) {
					tailleBufferDeb += INC_BUFFER_DEB;
					bufferDeb = (long *) monrealloc((void *) bufferDeb, tailleBufferDeb*sizeof(long));
				}
				bufferDeb[seq.nombre++] = seq.taille;
			} else {
				if(c != EOF)
					c = getc(f);
			}
		}
	}
	if(bufferSeq[seq.taille-1] != SEP) {
		if(seq.taille>=tailleBufferSeq) {
				tailleBufferSeq += INC_BUFFER_SEQ;
				bufferSeq = (long *) monrealloc((void *) bufferSeq, tailleBufferSeq*sizeof(long));
		}
		bufferSeq[seq.taille++] = SEP;
		if(seq.nombre>=tailleBufferDeb) {
				tailleBufferDeb += INC_BUFFER_DEB;
				bufferDeb = (long *) monrealloc((void *) bufferDeb, tailleBufferDeb*sizeof(long));
		}
		bufferDeb[seq.nombre] = seq.taille;
	} else {
		seq.nombre--;
	}
	seq.cardinal++;
	seq.debut= (long *) monrealloc((void *) bufferDeb, (seq.nombre+1)*sizeof(long));
	seq.sequence = (long *) monrealloc((void *) bufferSeq, seq.taille*sizeof(long)); 
	seq.premiere = (long *) monmalloc(seq.cardinal*sizeof(long));
	seq.suivant = (long *) monmalloc(seq.taille*sizeof(long));
	ConstruitPremSuiv(&seq);

	return seq;
}

/*Desalloue l'espace memoire dynamiquement attribue a "seq"*/
void LibereSequences(Sequences seq) {
	monfree((void *) seq.debut);
	monfree((void *) seq.sequence);
	monfree((void *) seq.premiere);
	monfree((void *) seq.suivant);
}

/*Ecrit la sequence "seq" dans "f"*/
/*void EcritSequences(FILE *f, Sequences seq) {
	long position;
	for(position=0; position<seq.taille; position++) {
		if(seq.sequence[position] != SEP)
			fprintf(f, "%ld ", seq.sequence[position]);
		else {
			for(; position<seq.taille-1 && seq.sequence[position+1] == SEP; position++);
			fprintf(f, "\n");
		}
	}
}
*/
void EcritSequences(FILE *f, Sequences seq) {
	long position, n;
	for(n=0; n<seq.nombre; n++) {
		for(position=seq.debut[n]; position<seq.debut[n+1]; position++)
			if(seq.sequence[position] != SEP)
				fprintf(f, "%ld ", seq.sequence[position]);
		fprintf(f, "\n");
	}
}

void EcritSequencesFASTA(FILE *f, Sequences seq) {
	long position, n;
	for(n=0; n<seq.nombre; n++) {
		fprintf(f, ">sequence %ld\n", n+1);
		for(position=seq.debut[n]; position<seq.debut[n+1]; position++)
			if(seq.sequence[position] != SEP)
				fprintf(f, "%ld ", seq.sequence[position]);
		fprintf(f, "\n\n");
	}
}

/*Renvoie une "hard-copy" de "s"*/
Sequences Clone(Sequences s) {
	long i;
	Sequences res;

	res.nombre = s.nombre;
	res.cardinal = s.cardinal;
	res.taille = s.taille;
	res.debut = (long*) monmalloc((res.nombre+1)*sizeof(long));
	res.premiere = (long*) monmalloc(res.cardinal*sizeof(long));
	res.sequence = (long*) monmalloc(res.taille*sizeof(long));
	res.suivant = (long*) monmalloc(res.taille*sizeof(long));
	for(i=0; i<=res.nombre; i++)
		res.debut[i] = s.debut[i];
	for(i=0; i<res.cardinal; i++)
		res.premiere[i] = s.premiere[i];
	for(i=0; i<res.taille; i++) {
		res.sequence[i] = s.sequence[i];
		res.suivant[i] = s.suivant[i];
	}
	
	return res;
}

/*Renvoie l'indice de la sequence incluant "position"*/
long TrouveSequence(long position, Sequences seq) {
	long i;
	for(i=1; i<=seq.nombre; i++)
		if(position<seq.debut[i])
			return i-1;
	return seq.nombre-1;
}

/*Chaine les occurrence des lettres de "seq", et instancie les champs correspondant dans la structure*/
void ConstruitPremSuiv(Sequences *seq) {
	long position, lettre;

	for(lettre=0; lettre<seq->cardinal; lettre++) {
		seq->premiere[lettre] = FIN;
	}
	for(position=seq->taille-1; position>=0; position--)
		if(seq->sequence[position] != SEP) {
			seq->suivant[position] = seq->premiere[seq->sequence[position]];
			seq->premiere[seq->sequence[position]] = position;
		}
}

/*Renvoie la N_ecriture de la sequence "seq"*/
Sequences Calcule_N_Ecriture(Sequences seq, long N) {
	int ok;
	long position, lettre, N_lettre, N_Courant, nombnouv, i,
		Cardinal_Alphabet_Courant, dernier, 
		suivant_temporaire, Cardinal_Temporaire, 
		*Precedent_Temporaire ,*tabnouv, 
		*Premiere_Occurence_0, *Premiere_Occurence_1,  *Premiere_Occurence_Final,
		*Suivant, *N_Ecriture;
	Sequences res;

	if(N <= 1 || seq.taille <= 0)
		return Clone(seq);
/*Allocations de memoire*/
	Premiere_Occurence_0 = (long *) monmalloc(seq.taille*sizeof(long));
	Premiere_Occurence_1 = (long *) monmalloc(seq.taille*sizeof(long));
	Suivant = (long *) monmalloc(seq.taille*sizeof(long));
	Precedent_Temporaire = (long *) monmalloc(seq.cardinal*sizeof(long));
	tabnouv = (long *) monmalloc(seq.cardinal*sizeof(long));
/*Initialisations*/
	for(position=0; position<seq.taille; position++)
		Suivant[position] = seq.suivant[position];
	for(lettre=0; lettre<seq.cardinal; lettre++)
		Premiere_Occurence_0[lettre] = seq.premiere[lettre];
	for(lettre=0; lettre<seq.cardinal; lettre++)
		Precedent_Temporaire[lettre] = -1;
/*Construction de la N-ecriture*/
	Cardinal_Alphabet_Courant = seq.cardinal;
	for(N_Courant=1; N_Courant<N; N_Courant++) {
		long derniere_lettre, position_derniere_lettre, *tmp;
		
		Cardinal_Temporaire = Cardinal_Alphabet_Courant;
		Cardinal_Alphabet_Courant = 0;
		for(N_lettre=0; N_lettre<Cardinal_Temporaire; N_lettre++) {
			position = Premiere_Occurence_0[N_lettre];
			nombnouv = 0;
			while(position != FIN) {
				position_derniere_lettre = position+N_Courant;
				if(position_derniere_lettre<seq.taille && seq.sequence[position_derniere_lettre] != SEP) {
					derniere_lettre = seq.sequence[position_derniere_lettre];
					if(Precedent_Temporaire[derniere_lettre]<0) {
						Premiere_Occurence_1[Cardinal_Alphabet_Courant++] = position;
						tabnouv[nombnouv++] = derniere_lettre;
					} else
						Suivant[Precedent_Temporaire[derniere_lettre]] = position;
					Precedent_Temporaire[derniere_lettre] = position;
				}
				position = Suivant[position];
			}
			for(i=0; i<nombnouv; i++) {
				Suivant[Precedent_Temporaire[tabnouv[i]]] = -1;
				Precedent_Temporaire[tabnouv[i]] = -1;				
			}
		}
		tmp = Premiere_Occurence_0;
		Premiere_Occurence_0 = Premiere_Occurence_1;
		Premiere_Occurence_1 = tmp;
	}
	
	Premiere_Occurence_Final = (long *) monrealloc((void *) Premiere_Occurence_0, Cardinal_Alphabet_Courant*sizeof(long));
	N_Ecriture = Premiere_Occurence_1; 

	monfree((void *) Precedent_Temporaire);
	monfree((void *) tabnouv);
	
	for(position = 0; position < seq.taille; position++)
		N_Ecriture[position] = SEP;

	for(lettre=0; lettre<Cardinal_Alphabet_Courant; lettre++) {
		position = Premiere_Occurence_Final[lettre];
		while(position != FIN) {
			N_Ecriture[position] = lettre;
			position = Suivant[position];
		}
	}
	monfree((void*) Premiere_Occurence_Final);
	monfree((void*) Suivant);

	res.debut = (long*) monmalloc((seq.nombre+1)*sizeof(long));

	res.cardinal = Cardinal_Alphabet_Courant;
	res.sequence = N_Ecriture;
	res.debut[0] = 0;
	res.nombre = 1;
	res.taille = 1;
	for(position=1; position<seq.taille; position++)
		if(res.sequence[position-1] != SEP || res.sequence[position] != SEP)
			res.sequence[res.taille++] = res.sequence[position];
		else
			if(res.nombre<seq.nombre)
				res.debut[res.nombre++] = res.taille;
	if(res.sequence[res.taille-1] == SEP)
		res.taille--;
	res.debut[seq.nombre] = res.taille;
	res.sequence = (long*) monrealloc((void*) res.sequence, res.taille*sizeof(long));
	res.premiere = (long *) monmalloc(res.cardinal*sizeof(long));
	res.suivant = (long *) monmalloc(res.taille*sizeof(long));
	ConstruitPremSuiv(&res);
	return res;
}

/*Renvoie l'antecedent maximal a l'ordre N de "seq"*/
Sequences Calcule_N_Antecedent(Sequences seq, long N) {
	long lettre, position, i, N_Cardinal, tailleMax, dernier, **Projection;
	Element_Pile *Pile;
	Sequences res;
	if(N <= 1 || seq.taille == 0 || seq.cardinal == 0)
		return Clone(seq);
/*Allocations de memoire et Initialisations*/
	Pile = (Element_Pile *) monmalloc(N*seq.cardinal*sizeof(Element_Pile));
	Projection = (long **) monmalloc(N*sizeof(long *));
	for(i=0 ; i<N; i++) {
		Projection[i] = (long *) monmalloc(seq.cardinal*sizeof(long));
		for(lettre=0; lettre<seq.cardinal; lettre++)
			Projection[i][lettre] = -1;
	}
	N_Cardinal = 0;
	dernier=-1;
/*Boucle de construction de la table des projections*/
	for(lettre=0; lettre<seq.cardinal; lettre++) {
		long i;
		for(i=0; i<N; i++)
			if(Projection[i][lettre] == -1) {
				Pile[++dernier].lettre = lettre;
				Pile[dernier].indice = i;
				Projection[i][lettre] = N_Cardinal;
				while(dernier>=0) {
					Element_Pile courant;
					courant = Pile[dernier--];
					position = seq.premiere[courant.lettre];
					while(position >= 0) {
						long k, lettre_k;
						for(k=1; k<=courant.indice && (position+k)<seq.taille && (lettre_k = seq.sequence[position+k]) != SEP; k++)
							if(Projection[courant.indice-k][lettre_k] == -1) {
								Pile[++dernier].lettre = lettre_k;
								Pile[dernier].indice = courant.indice-k;
								Projection[courant.indice-k][lettre_k] = N_Cardinal;
							}
						for(k=1; k<(N-courant.indice) && (position-k)>=0 && (lettre_k = seq.sequence[position-k]) != SEP ; k++)
							if(Projection[courant.indice+k][lettre_k] == -1) {
								Pile[++dernier].lettre = lettre_k;
								Pile[dernier].indice = courant.indice+k;
								Projection[courant.indice+k][lettre_k] = N_Cardinal;
							}
						position = seq.suivant[position];
					}
				}
				N_Cardinal++;
			}
	}

	monfree((void *) Pile);
	
	tailleMax = seq.taille+(N-1)*seq.nombre;
	res.sequence = (long *) monmalloc(tailleMax*sizeof(long));
	res.debut = (long*) monmalloc((seq.nombre+1)*sizeof(long));

/*projection de la sequence vers l'antecedent maximal*/	
	res.taille = 0; res.nombre = 1;
	res.debut[0] = 0;
	for(position=0; position<seq.taille; position++)
		if(seq.sequence[position] != SEP) {
			res.sequence[res.taille++] = Projection[0][seq.sequence[position]];
		} else {
			long repos;
			repos = position-1;
			if(seq.sequence[repos] != SEP) {
				for(i=1; i<N; i++)
					res.sequence[res.taille++] = Projection[i][seq.sequence[repos]];
				if(res.taille<tailleMax)
					res.sequence[res.taille++] = SEP;
				if(res.nombre<seq.nombre)
					res.debut[res.nombre++] = res.taille;
			}
		}

	if(seq.sequence[seq.taille-1] != SEP) {
		for(i=1; i<N && res.taille<tailleMax; i++)
			res.sequence[res.taille++] = Projection[i][seq.sequence[seq.taille-1]];
	}
	res.debut[seq.nombre] = res.taille;

	for(i=0 ; i<N; i++)
		monfree((void *) Projection[i]);
	monfree((void *) Projection);

	res.cardinal = N_Cardinal;
	res.sequence = (long*) monrealloc((void*) res.sequence, res.taille*sizeof(long));
	res.premiere = (long *) monmalloc(res.cardinal*sizeof(long));
	res.suivant = (long *) monmalloc(res.taille*sizeof(long));
	ConstruitPremSuiv(&res);
	return res;
}

/*Renvoie la N_ecriture de la sequence "seq"*/
Sequences *Calcule_N_Mismatch(Sequences seq, long N) {
	int ok;
	long position, lettre, N_lettre, N_Courant, nombnouv, i, *Precedent_Temporaire ,*tabnouv;
	Sequences *tab0, *tab1;

/*Allocations de memoire*/
	tab0 = (Sequences*) monmalloc( (long) (N*sizeof(Sequences)));
	tab1 = (Sequences*) monmalloc((long) (N*sizeof(Sequences)));

	Precedent_Temporaire = (long *) monmalloc(seq.cardinal*sizeof(long));
	tabnouv = (long *) monmalloc(seq.cardinal*sizeof(long));

/*Initialisations*/
	for(lettre=0; lettre<seq.cardinal; lettre++)
		Precedent_Temporaire[lettre] = -1;
	tab0[0].cardinal = 1;
	tab0[0].premiere = (long *) monmalloc(sizeof(long));
	tab0[0].suivant = (long *) monmalloc(seq.taille*sizeof(long));
	tab0[0].premiere[0] = FIN;
	for(position=seq.taille-1; position>=0; position--)
		if(seq.sequence[position] != SEP) {
			tab0[0].suivant[position] = tab0[0].premiere[0];
			tab0[0].premiere[0] = position;
		}
	for(N_Courant=1; N_Courant<N; N_Courant++) {
		Sequences *tabTmp;
		long i;
		for(i=0; i<=N_Courant; i++) {
			tab1[i].cardinal = 0;
			tab1[i].premiere = (long *) monmalloc(seq.taille*sizeof(long));
			tab1[i].suivant = (long *) monmalloc(seq.taille*sizeof(long));
		}
		for(i=0; i<N_Courant; i++) {
			for(N_lettre=0; N_lettre<tab0[i].cardinal; N_lettre++) {
				long j;
				position = tab0[i].premiere[N_lettre];
				nombnouv = 0;
				while(position != FIN) {
					long derniere_lettre, position_derniere_lettre;
					position_derniere_lettre = position+N_Courant;
					if(position_derniere_lettre<seq.taille && seq.sequence[position_derniere_lettre] != SEP) {
						derniere_lettre = seq.sequence[position_derniere_lettre];
						if(Precedent_Temporaire[derniere_lettre]<0) {
							tab1[i].premiere[tab1[i].cardinal++] = position;
							tabnouv[nombnouv++] = derniere_lettre;
						} else
							tab1[i].suivant[Precedent_Temporaire[derniere_lettre]] = position;
						Precedent_Temporaire[derniere_lettre] = position;
					}
					position = tab0[i].suivant[position];
				}
				for(j=0; j<nombnouv; j++) {
					tab1[i].suivant[Precedent_Temporaire[tabnouv[j]]] = FIN;
					Precedent_Temporaire[tabnouv[j]] = -1;
				}
			}
		}
		for(N_lettre=0; N_lettre<tab0[N_Courant-1].cardinal; N_lettre++) {
			long j;
			position = tab0[N_Courant-1].premiere[N_lettre];
			nombnouv = 0;
			while(position != FIN) {
				long premiere_lettre, position_premiere_lettre;
				position_premiere_lettre = position-1;
				if(position_premiere_lettre>=0 && seq.sequence[position_premiere_lettre] != SEP) {
					premiere_lettre = seq.sequence[position_premiere_lettre];
					if(Precedent_Temporaire[premiere_lettre]<0) {
						tab1[N_Courant].premiere[tab1[N_Courant].cardinal++] = position_premiere_lettre;
						tabnouv[nombnouv++] = premiere_lettre;
					} else
						tab1[i].suivant[Precedent_Temporaire[premiere_lettre]] = position_premiere_lettre;
					Precedent_Temporaire[premiere_lettre] = position_premiere_lettre;
				}
				position = tab0[N_Courant-1].suivant[position];
			}
			for(j=0; j<nombnouv; j++) {
				tab1[N_Courant].suivant[Precedent_Temporaire[tabnouv[j]]] = FIN;
				Precedent_Temporaire[tabnouv[j]] = -1;
			}
		}
		for(i=0; i<N_Courant; i++) {
			monfree((void*)tab0[i].premiere);
			monfree((void*)tab0[i].suivant);
		}
		tabTmp = tab0; tab0 = tab1; tab1 = tabTmp;
	}
	monfree((void*)tab1);
	for(N_Courant=0; N_Courant<N; N_Courant++) {
		long d;
		tab0[N_Courant].premiere = (long*) monrealloc(tab0[N_Courant].premiere, tab0[N_Courant].cardinal*sizeof(long));
		tab0[N_Courant].sequence = (long *) monmalloc(seq.taille*sizeof(long));
		tab0[N_Courant].taille = seq.taille;
		tab0[N_Courant].nombre = seq.nombre;
		tab0[N_Courant].debut =(long*) monmalloc((seq.nombre+1)*sizeof(long));
		for(d=0; d<=seq.nombre; d++)
			tab0[N_Courant].debut[d] = seq.debut[d];
		for(position = 0; position< seq.taille; position++)
			tab0[N_Courant].sequence[position] = SEP;
		for(lettre=0; lettre<tab0[N_Courant].cardinal; lettre++) {
			position = tab0[N_Courant].premiere[lettre];
			while(position != FIN) {
				tab0[N_Courant].sequence[position] = lettre;
				position = tab0[N_Courant].suivant[position];
			}
		}
	}
	monfree((void *) Precedent_Temporaire);
	monfree((void *) tabnouv);
	return tab0;
}

/*Renvoie l'antecedent maximal a l'ordre N de "seq"*/
Sequences Calcule_N_Antecedent_Mismatch(Sequences *tab, long N) {
	long lettre, position, i, N_Cardinal, tailleMax, dernier, **Projection, maxCard;
	Element_Pile *Pile;
	Sequences res;
	maxCard = tab[0].cardinal;
	for(i=1; i<N; i++)
		if(tab[i].cardinal > maxCard)
			maxCard = tab[i].cardinal;
/*Allocations de memoire et Initialisations*/
	Pile = (Element_Pile *) monmalloc(N*maxCard*sizeof(Element_Pile));
	Projection = (long **) monmalloc(N*sizeof(long *));
	for(i=0 ; i<N; i++) {
		Projection[i] = (long *) monmalloc(tab[i].cardinal*sizeof(long));
		for(lettre=0; lettre<tab[i].cardinal; lettre++)
			Projection[i][lettre] = -1;
	}
	N_Cardinal = 0;
	dernier=-1;
/*Boucle de construction de la table des projections*/
	for(i=0; i<N; i++)
		for(lettre=0; lettre<tab[i].cardinal; lettre++) {
			if(Projection[i][lettre] == -1) {
				Pile[++dernier].lettre = lettre;
				Pile[dernier].indice = i;
				Projection[i][lettre] = N_Cardinal;
				while(dernier>=0) {
					Element_Pile courant;
					courant = Pile[dernier--];
					position = tab[courant.indice].premiere[courant.lettre];
					while(position >= 0) {
						long k, lettre_k;
						for(k=1; k<=courant.indice && (position+k)<tab[courant.indice-k].taille && (lettre_k = tab[courant.indice-k].sequence[position+k]) != SEP; k++)
							if(Projection[courant.indice-k][lettre_k] == -1) {
								Pile[++dernier].lettre = lettre_k;
								Pile[dernier].indice = courant.indice-k;
								Projection[courant.indice-k][lettre_k] = N_Cardinal;
							}
						for(k=1; k<(N-courant.indice) && (position-k)>=0 && (lettre_k = tab[courant.indice+k].sequence[position-k]) != SEP ; k++)
							if(Projection[courant.indice+k][lettre_k] == -1) {
								Pile[++dernier].lettre = lettre_k;
								Pile[dernier].indice = courant.indice+k;
								Projection[courant.indice+k][lettre_k] = N_Cardinal;
							}
						position = tab[courant.indice].suivant[position];
					}
				}
				N_Cardinal++;
			}
	}

	monfree((void *) Pile);
	
	tailleMax = tab[0].taille;
	res.sequence = (long *) monmalloc(tailleMax*sizeof(long));
	res.debut = (long*) monmalloc((tab[0].nombre+1)*sizeof(long));

/*projection de la sequence vers l'antecedent maximal*/	
	res.taille = 0; res.nombre = 1;
	res.debut[0] = 0;
	for(position=0; position<tab[0].taille; position++)
		if(tab[0].sequence[position] != SEP) {
			res.sequence[res.taille++] = Projection[0][tab[0].sequence[position]];
		} else {
			long repos;
			repos = position-1;
			if(tab[0].sequence[repos] != SEP) {
				for(i=1; i<N; i++)
					res.sequence[res.taille++] = Projection[i][tab[i].sequence[repos]];
				if(res.taille<tailleMax)
					res.sequence[res.taille++] = SEP;
				if(res.nombre<tab[0].nombre)
					res.debut[res.nombre++] = res.taille;
			}
		}

	if(tab[0].sequence[tab[0].taille-1] != SEP) {
		for(i=1; i<N && res.taille<tailleMax; i++)
			res.sequence[res.taille++] = Projection[i][tab[i].sequence[tab[i].taille-1]];
	}
	res.debut[tab[0].nombre] = res.taille;

	for(i=0 ; i<N; i++)
		monfree((void *) Projection[i]);
	monfree((void *) Projection);

	res.cardinal = N_Cardinal;
	res.sequence = (long*) monrealloc((void*) res.sequence, res.taille*sizeof(long));
	res.premiere = (long *) monmalloc(res.cardinal*sizeof(long));
	res.suivant = (long *) monmalloc(res.taille*sizeof(long));
	ConstruitPremSuiv(&res);
	return res;
}

