
#ifndef SequencesOldF
#define SequencesOldF

#include <stdlib.h>
#include <stdio.h>
#include "Sequences.h"

/*Structure contenant un ensemble de sequence*/
typedef struct SEQUENCES {
/*taille totale du tableau "sequence"*/
	long taille;
/*nombre de sequences contenu dans l'ensemble*/
	long nombre;
/*cardinal de l'alphabet*/
	long cardinal;
/*debut[i] est l'indice du debut de la sequence i dans le tableau "sequences"*/
	long *debut;
/*premiere[a] pointe vers la premiere position de la lettre a*/
	long *premiere;
/*tableau contenant l'ensemble des sequences separees par "SEP"*/
	long *sequence;
/*suivant[i] continet l'indice de l'occurence suivante de lettre presente en position i,
-1 s'il n'y en a pas*/
	long *suivant;
} Sequences;



Sequences toOldSequences(TypeSetOfSequences set);
void EcritSequencesFASTA(FILE *f, Sequences seq);

/*Lit l'ensemble de sequences contenu dans le fichier texte "f", et renvoie la structure correspondante
Le format est le suivant : les sequences sont des nombres separes 
par des espaces, les sequences sont separees par des sauts de lignes*/
Sequences LitSequences(FILE *f);

/*Ecrit la sequence "seq" dans "f"*/
void EcritSequences(FILE *f, Sequences seq);

/*Desalloue l'espace memoire dynamiquement attribue a "seq"*/
void LibereSequences(Sequences seq);

/*Renvoie la N_ecriture de la sequence "seq"*/
Sequences Calcule_N_Ecriture(Sequences seq, long N);

/*Renvoie l'antecedent maximal a l'ordre N de "seq"*/
Sequences Calcule_N_Antecedent(Sequences seq, long N);

/*Renvoie une "hard-copy" de "s"*/
Sequences Clone(Sequences s);

/*Renvoie l'indice de la sequence incluant "position"*/
long TrouveSequence(long position, Sequences seq);

Sequences *Calcule_N_Mismatch(Sequences seq, long N);

Sequences Calcule_N_Antecedent_Mismatch(Sequences *tab, long N);

#define SEP -1
#define FIN -1

#endif
