#! /usr/bin/env python

# -*- coding: iso-8859-1 -*-
##
##  Copyright (C) 2010 E. Corel, G. Didier, C. Devauchelle, G. Grasseau
##
##  This program is free software; you can redistribute it and/or modify
##  it under the terms of the GNU General Public License as published by
##  the Free Software Foundation; either version 2 of the License, or (at
##  your option) any later version.
## 
##  This program is distributed in the hope that it will be useful, but
##  WITHOUT ANY WARRANTY; without even the implied warranty of
##  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
##  General Public License for more details.
## 
##  You should have received a copy of the GNU General Public License
##  along with this program; if not, write to the Free Software
##  Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
## 
##

import sys,getopt,os,time
#from altgraph import Graph
# A voir ???
import AnchorSet, Matrix

## Abstract Class to build EquivClasses.
#
#  More details ???.
class AnchorOperator:

    ## Virtual method to .
    #  @param self the object pointer.
    #  @param object_base an object from which the anchors are determined.
    #
    #  More details ???.
    def operate( self, object_base=None):
        raise NotImplementedError

## Class to build EquivClasses using exact NLD method.
#
#  More details ???.

class AnchorSminFilter(AnchorOperator):

    def operate( self, AnchorSet_, value_ = 2):
        # GG ??? accesseurs
        newdict_ =  dict( AnchorSet_ .anchors )
        for node in AnchorSet_.anchors.keys():
             seq_list = [pos[0] for pos in AnchorSet_.anchors[node] ]
             seg_counts = [seq_list.count(s) for s in set(seq_list)]
             sum_seq_counts = reduce(lambda x,y:x+y,seg_counts)
             # ??? flag[ node ] = (sum_seq_counts >= value_ )
             if (sum_seq_counts < value_ ) :
                 del newdict_[ node ]
        return  AnchorSet.AnchorSet( newdict_ )

class DistanceMatrix(AnchorOperator):

    def operate( self, AnchorSet_, SeqSet_, process="norm") :


        # Define the matrix
        dim_mat = len(SeqSet_.SeqNames)
        m = Matrix.Matrix( dim_mat,dim_mat )

        for c in AnchorSet_.anchors.keys():
            # Get the list of sequences where anchor c appears
            seq = map(lambda x:x[0],AnchorSet_.anchors[c]) 

            # Remove duplicate 
            seqset = list(set(seq))
            # Sort List
            seqset.sort(key=lambda x:int(x),cmp=lambda x,y:x-y)

            # Counts of times where anchor c appears in sequence s 
            counts = dict([(s,seq.count(s)) for s in seqset]) 


            # Number of different sequences where anchor c appears 
            k = len(seqset)
            for i in range(k):
                for j in range(k)[i+1:]:
                    m.matrix[seqset[i]][seqset[j]] += min( counts[seqset[i]], 
                                                    counts[seqset[j]] )
        if ( process == "norm" ):
            # get sequence lengths 
            lengths = dict( [(i,len(SeqSet_.sites[i])) 
                             for i in SeqSet_.sites.keys()] )

            # Normalization
            k = dim_mat
            for i in range(k):
                for j in range(k)[i+1:]:
                    m.matrix[i][j] = 1 - float(m.matrix[i][j]) \
                        / float(min(lengths[i],lengths[j]))
            for i in range(k):
                for j in range(k)[:i]:
                    m.matrix[i][j] = m.matrix[j][i]
        return m

