#! /usr/bin/env python

# -*- coding: iso-8859-1 -*-

##
##  Copyright (C) 2010 E. Corel, G. Didier, C. Devauchelle, G. Grasseau
##
##  This program is free software; you can redistribute it and/or modify
##  it under the terms of the GNU General Public License as published by
##  the Free Software Foundation; either version 2 of the License, or (at
##  your option) any later version.
## 
##  This program is distributed in the hope that it will be useful, but
##  WITHOUT ANY WARRANTY; without even the implied warranty of
##  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
##  General Public License for more details.
## 
##  You should have received a copy of the GNU General Public License
##  along with this program; if not, write to the Free Software
##  Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
## 
##

## @package BuildAnchorSet
#  Short documentation (sum up).
#
#  More details ???.


# Importation de modules

import EquivClassesLayers, PartitionTree, AnchorSet
import re, sys,os,itertools,time
from math import ceil
import altgraph
#import boost.graph as bgl
# import networkx as NX
from altgraph import Graph, GraphAlgo, Dot
from collections import deque
import string
# GG ???
TIMETEST = 0

## Abstract Class to build EquivClasses.
#
#  More details ???.
class BuildAnchorSet:

    ## Virtual method to .
    #  @param self the object pointer.
    #  @param object_base an object from which the anchors are determined.
    #
    #  More details ???.
    def build( self, object_base=None):
        raise NotImplementedError


## Class to build EquivClasses using exact NLD method.
#
#  More details ???.
class BuildAnchorSetFromEClayers(BuildAnchorSet):

    ## Constructor .
    def __init__( self ):
        return
    
    def build( self, ECLayers_, kappa ):
        """ Return an AnchorSet object """

        self._ptree_ = PartitionTree.PartitionTree( ECLayers_ )

        # GG ??? remark smin = 1

        # ??? Il faudrait fusionner les 2
        # pborder  = self.doSminFilter();
        # pborder = _ptree_.getNodesFilteredBySequenceNbr( )
        # nodeList = _ptree_.getBorderNodes(lambda x:pborder[x])

        # Get the PT nodes pruned 
        nodesList  = self._ptree_.prune( kappa )

        # Get sites list
        sites_dict  = dict([(n, self._ptree_.childLeaves(n) ) for n in nodesList]) 
        
        anchors  = AnchorSet.AnchorSet(sites_dict) 
      
        return anchors
    
    ## build motifs list (using getMotif)
    ## In test not validated
    def buildMotif( self, ECLayers_, spread_filter ):
        """ Return an AnchorSet object """

        self._ptree_ = PartitionTree.PartitionTree( ECLayers_ )

        # GG ??? remark smin = 1

        # ??? Il faudrait fusionner les 2
        # pborder  = self.doSminFilter();
        # pborder = _ptree_.getNodesFilteredBySequenceNbr( )
        # nodeList = _ptree_.getBorderNodes(lambda x:pborder[x])

        # Get the PT nodes pruned 
        nodesList  = self._ptree_.getMotif( spread_filter )

        # Get sites list
        sites_dict  = dict([(n, self._ptree_.childLeaves(n) ) for n in nodesList]) 
        
        anchors  = AnchorSet.AnchorSet(sites_dict) 
      
        return anchors

    def savePTree( self, name=None, format="dot" ):
        """ Save PTree """

        if ( format == "dot"):
            self._ptree_.saveTree(fileout=name,ext='.dot')
        
        
    def writePTree(self, name_ = "ptree.dot", kappa=1, detail=False):

        nodesList  = self._ptree_.prune(kappa)
        self._ptree_.writePTree( name_, tagnodes= nodesList, detail=detail)


    ## ??? Invalid with the new calulation of kappa
    def checkPTree(self, anchors=None):

        valid = True
        for n in anchors.anchors.keys():
            pred = self._ptree_.inc_nbrs( n )
            if( (self._ptree_.criterion[n][1] != 1) and (len(pred) != 1) ):
                sys.stderr.write('Not valid anchors: '+ n + 
                                 ' is a redondant EC or has several predecessors\n')    
                valid = False
            else:
                if( self._ptree_.criterion[ pred[0] ][1] != 0 ):
                    sys.stderr.write('Not valid anchors: predecessor of '+ n + 
                                     '  is a non-redondant EC\n')    
                    valid = False

        return ( valid )

## Class to build EquivClasses using exact NLD method.
#
#  More details ???.
class BuildAnchorSetFromPTree(BuildAnchorSet):

    ## Constructor .
    def __init__( self ):
        return
    
    def build( self, PTree_, kappa ):
        """ Return an AnchorSet object """

        # GG ??? remark smin = 1

        # ??? Il faudrait fusionner les 2
        # pborder  = self.doSminFilter();
        # pborder = _ptree_.getNodesFilteredBySequenceNbr( )
        # nodeList = _ptree_.getBorderNodes(lambda x:pborder[x])

        # Get the PT nodes pruned with doSminFilter() 
        nodesList  = PTree_.prune(kappa);
  
        # Get sites list
        sites_dict  = dict([(n, self._ptree_.childLeaves(n) ) for n in nodesList]) 
        
        anchors  = AnchorSet.AnchorSet(sites_dict) 
      
        return anchors
    




