#! /usr/bin/env python

# -*- coding: iso-8859-1 -*-

##
##  Copyright (C) 2010 E. Corel, G. Didier, C. Devauchelle, G. Grasseau
##
##  This program is free software; you can redistribute it and/or modify
##  it under the terms of the GNU General Public License as published by
##  the Free Software Foundation; either version 2 of the License, or (at
##  your option) any later version.
## 
##  This program is distributed in the hope that it will be useful, but
##  WITHOUT ANY WARRANTY; without even the implied warranty of
##  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
##  General Public License for more details.
## 
##  You should have received a copy of the GNU General Public License
##  along with this program; if not, write to the Free Software
##  Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
## 
##

import os, sys 

    # This matrix class, is implemented as a list of lines
class Matrix:

    # Matrix size 
    n_row      = None
    n_col      = None

    # Matrix data
    matrix = None

    def __init__( self, n_row=1, n_col=1, val=0):
        self.n_row = n_row
        self.n_col = n_col
        self.matrix = [ [ val ]*n_col for i in range(n_row)]

    # Prints the matrix
    def display(self,format='(%3d,%3d)'):
        l,c = self.n_row, self.n_col

        # Matrix format
        form = '"'+format
        for i in range(c-1):
            form += ' '+format
        form += '"'
        # Print
        for j in range(l):
            line = ()
            for i in range(c):
                line += (self.matrix[j][i],)
            print form % line    

    ### Write de matrix content in a file with the "nexus" format
    def writeNexus( self,  filename, labels, format='%.3f ', 
                    comment='', ext=None):

        if not isinstance(filename, str): 
            sys.exit("writeNexus: No file name")

        if isinstance(ext, str): 
            filename = filename + ext

        # Open file
        fname = filename 
        f = open(fname,'w')
        nm = {}

    
        # Nexus header
        f.write('#NEXUS\n\n')
        titre = '[Distance matrix calculated by '+comment+']\n\n'
        f.write(titre)                                  # titre
        f.write('BEGIN taxa;\n')                # labels
        dimension = '\tDIMENSIONS ntax = %d;\n' % (self.n_row) # - elt[0]
        f.write(dimension)
        f.write('TAXLABELS\n')
        for i in xrange(0,self.n_row):
            nm[i] = labels[i].replace(' ','_').replace('/','-')
            f.write('\t'+nm[i]+'\n')
        f.write(';\n')
        f.write('END;\n\n')
        f.write('BEGIN distances;\n')   # header distances
        f.write(dimension)
        f.write('\tFORMAT\n')
        f.write('\t\ttriangle=BOTH\n')
        f.write('\t\tdiagonal\n')
        f.write('\t\tlabels\n')
        f.write(';\n')
        f.write('MATRIX\n')
    
        # Write matrix
        for i in xrange( 0, self.n_row ):
            ligne = nm[i]+'\t'
            # ??? parcours une ligne de la matrice (sauf elt0)
            for d in self.matrix[i]:  
                w = format % (d) 
                # Append new value     
                ligne = ligne + w     
                ligne = ligne+'\n'
            f.write(ligne)
        f.write(';\n')
        f.write('END;\n')
        f.close()
